#include "Joueur.h"

// Variables globales dclares dans un autre fichier
extern int NbColonnes;
extern int NbLignes;
extern char** Matrice;

// Dessin du joueur
void Joueur::Dessiner()
{
    glPushMatrix();
    glTranslated(PosC+0.5, PosL+0.5, 0.0);
        glColor3d(0.0, 0.0, 0.0);       // Couleur noire
        glutSolidSphere(0.3, 12, 12);   // Sphre de la tte

        glColor3d (1.0, 1.0, 0.0);         // Couleur jaune
        glTranslated(0.1, -0.1, 0.0);
            glutSolidSphere(0.05, 12, 12); // Premier oeil
        glTranslated(-0.2, 0.0, 0.0);
            glutSolidSphere(0.05, 12, 12); // Deuxime oeil
    glPopMatrix();
}

// Fonctions de dplacement :
void Joueur::BougerEnHaut() {
    if(PosL>0 && Matrice[PosC][PosL-1]!='0')
        PosL--;
}

void Joueur::BougerEnBas() {
    if(PosL<NbLignes-1 && Matrice[PosC][PosL+1]!='0')
        PosL++;
}

void Joueur::BougerAGauche() {
    if(PosC>0 && Matrice[PosC-1][PosL]!='0')
        PosC--;
}

void Joueur::BougerADroite() {
    if(PosC<NbColonnes-1 && Matrice[PosC+1][PosL]!='0')
        PosC++;
}
