 // La fonction membre Dessiner a besoin d'OpenGL
#include "GL/glut.h"

// Classe Joueur
class Joueur
{
private:
    // position Colonne/Ligne sur la matrice
    int PosC, PosL;
public:
    // Accesseurs :
    int GetPosC()  const {return PosC;}
    int GetPosL()  const {return PosL;}

    // Mutateurs :
    void SetPosC(int C)  {PosC = C;}
    void SetPosL(int L)  {PosL = L;}

    // Constructeur par dfaut :
    Joueur() {
        PosC = PosL = 0;
    }

	// Fonctions de dplacement :
	void BougerEnHaut();
	void BougerEnBas();
	void BougerAGauche();
	void BougerADroite();

	// Dessin de l'avatar joueur :
	void Dessiner();
};
