// Document.h
using namespace System::Drawing;
using namespace System::Collections;

namespace gouache
{
	public ref class Document
	{
	private:
		// chap2 ...
		//int pvLargeur;	
		//int pvHauteur;
		//Graphics^ graphics;
		//Bitmap^	pvBmp;
		// ... chap2

		ArrayList^ listeVues;
		FenetreApp^ app;	
		String^ pvNomDeFichier;
		String^ pvTitre;

		// modif
		bool pvModification;

		//// fermeture
		//bool pvFermetureEnCours;
		
	public:

		// ouvre une image existante
		Document ( FenetreApp^ app, String^ fichier );
		// cre une image vide, de dimensions donnes
		Document ( FenetreApp^ app, int tailleX, int tailleY );

		void NouvelleVue (void);
		bool EnregistrerDocument ( String^ fichier );

		bool FermerDocument (void);
		bool AutorisationFermerVue (Vue^ vue);

		//event DelegueChangeTitre^ evenementChangeTitre;

		//void DessineEllipse ( Point pt1, Point pt2 );
		//void DessineRectangle ( Point pt1, Point pt2 );
		//void DessineLigne ( Point pt1, Point pt2 );
		//void DessineTexte ( Point p );

		//void PotPeinture ( Point point );
		//void PotPeinturePixel ( int x, int y, Color ancienneCouleur, Queue^ file );

		//// chap2 ...
		//property int largeur {
		//	int get() { return pvLargeur; }
		//}
		//property int hauteur {
		//	int get() { return pvHauteur; }
		//}
		//property Bitmap^ bmp {
		//	Bitmap^ get() { return (Bitmap^)pvBmp->Clone(); }
		//}
		//// ... chap2

		//property bool fermetureEnCours {
		//	bool get() { return pvFermetureEnCours; }
		//}
		property bool modification {
			bool get() { return pvModification; }
		}
		property String^ nomDeFichier {
			String^ get() { return (String^)pvNomDeFichier->Clone(); }
		}
		property String^ titre {
			String^ get() { return (String^)pvTitre->Clone(); }
		}

	};
}